searchData={"items":[{"type":"module","title":"Kuddle.Config","doc":"Utility module for handling various sources of configuration using Kuddle.","ref":"Kuddle.Config.html"},{"type":"function","title":"Kuddle.Config.load_config_blob/2","doc":"Load a config map from a given kdl blob.\n\nUsage:\n\n    {:ok, config} = Kuddle.Config.load_config_blob(\"\"\"\n    my_application {\n      key \"value\"\n      key2 subkey=\"subvalue\"\n    }\n    \"\"\")","ref":"Kuddle.Config.html#load_config_blob/2"},{"type":"function","title":"Kuddle.Config.load_config_directory/3","doc":"Load config from a directory, the extensions of the config files must be supplied as well.\n\nUsage:\n\n    {:ok, config} =\n      Kuddle.Config.load_config_directory(\"/path/to/kdl/config/directory\", [\".kdl\", \".kuddle\"])","ref":"Kuddle.Config.html#load_config_directory/3"},{"type":"function","title":"Kuddle.Config.load_config_document/2","doc":"Load config from a given kuddle document.\n\nUsage:\n\n  {:ok, config} =\n    Kuddle.Config.load_config_document(document)","ref":"Kuddle.Config.html#load_config_document/2"},{"type":"function","title":"Kuddle.Config.load_config_file/2","doc":"Load a KDL config file\n\nUsage:\n\n    {:ok, config} = Kuddle.Config.load_config_file(\"/path/to/kdl/config/file\")","ref":"Kuddle.Config.html#load_config_file/2"},{"type":"module","title":"Kuddle.Config.DirectoryProvider","doc":"Use Kuddle as a config provider for a directory, if you want to load a single file see\nKuddle.Config.Provider instead","ref":"Kuddle.Config.DirectoryProvider.html"},{"type":"module","title":"Example - Kuddle.Config.DirectoryProvider","doc":"defp releases do\n      [\n        application: [\n          config_providers: [\n            {Kuddle.Config.Provider, [\n              paths: [\n                {:system, \"PATH_TO_CONFIG\", \"/default/path/to/kdl/config\"}\n              ],\n              extensions: [\".kdl\", \".kuddle\"]\n            ]}\n          ]\n        ]\n      ]\n    end","ref":"Kuddle.Config.DirectoryProvider.html#module-example"},{"type":"type","title":"Kuddle.Config.DirectoryProvider.extensions_option/0","doc":"Specify a list of extensions that should be treated as kdl files.\n\nDefault: [\".kdl\"]\n\nExample:\n\n    [\n      extensions: [\".kdl\", \".kuddle\"]\n    ]","ref":"Kuddle.Config.DirectoryProvider.html#t:extensions_option/0"},{"type":"type","title":"Kuddle.Config.DirectoryProvider.option/0","doc":"","ref":"Kuddle.Config.DirectoryProvider.html#t:option/0"},{"type":"type","title":"Kuddle.Config.DirectoryProvider.options/0","doc":"Options supported by the DirectoryProvider\n\nExample:\n\n    [\n      paths: [\n        \"/etc/my_application/config\"\n      ],\n      extensions: [\".cfg.kdl\", \".cfg.kuddle\"]\n    ]","ref":"Kuddle.Config.DirectoryProvider.html#t:options/0"},{"type":"type","title":"Kuddle.Config.DirectoryProvider.paths_option/0","doc":"The directory provider allows specifying multiple paths to get config files from, this path\nwill be joined with the wildcard **/* and postfixed with the extensions.\n\nExample:\n\n    [\n      paths: [\n        \"/etc/my_application/config\"\n      ]\n    ]","ref":"Kuddle.Config.DirectoryProvider.html#t:paths_option/0"},{"type":"module","title":"Kuddle.Config.Distillery.DirectoryProvider","doc":"Use Kuddle as a config provider for a directory, if you want to load a single file see\nKuddle.Config.Provider instead","ref":"Kuddle.Config.Distillery.DirectoryProvider.html"},{"type":"module","title":"Example - Kuddle.Config.Distillery.DirectoryProvider","doc":"release :default do\n      set config_providers: [\n        {Kuddle.Config.Provider, [\n          paths: [\n            {:system, \"PATH_TO_CONFIG\", \"/default/path/to/kdl/config\"}\n          ],\n          extensions: [\".kdl\", \".kuddle\"]\n        ]}\n      ]\n    end","ref":"Kuddle.Config.Distillery.DirectoryProvider.html#module-example"},{"type":"function","title":"Kuddle.Config.Distillery.DirectoryProvider.init/1","doc":"","ref":"Kuddle.Config.Distillery.DirectoryProvider.html#init/1"},{"type":"module","title":"Kuddle.Config.Distillery.Provider","doc":"Use Kuddle as a config provider for a single file, if you want to load a directory see\nKuddle.Config.Distillery.DirectoryProvider instead.\n\nThis is a variant of the Config.Provider specifically used for Distillery","ref":"Kuddle.Config.Distillery.Provider.html"},{"type":"module","title":"Example - Kuddle.Config.Distillery.Provider","doc":"release :default do\n      set config_providers: [\n        {Kuddle.Config.Provider, [\n          path: {:system, \"PATH_TO_CONFIG\", \"/default/path/to/kdl/config\"}\n        ]}\n      ]\n    end","ref":"Kuddle.Config.Distillery.Provider.html#module-example"},{"type":"function","title":"Kuddle.Config.Distillery.Provider.init/1","doc":"","ref":"Kuddle.Config.Distillery.Provider.html#init/1"},{"type":"module","title":"Kuddle.Config.Provider","doc":"Use Kuddle as a config provider for a single file, if you want to load a directory see\nKuddle.Config.DirectoryProvider instead","ref":"Kuddle.Config.Provider.html"},{"type":"module","title":"Example - Kuddle.Config.Provider","doc":"defp releases do\n      [\n        application: [\n          config_providers: [\n            {Kuddle.Config.Provider, [\n              path: {:system, \"PATH_TO_CONFIG\", \"/default/path/to/kdl/config\"}\n            ]}\n          ]\n        ]\n      ]\n    end","ref":"Kuddle.Config.Provider.html#module-example"},{"type":"type","title":"Kuddle.Config.Provider.option/0","doc":"","ref":"Kuddle.Config.Provider.html#t:option/0"},{"type":"type","title":"Kuddle.Config.Provider.options/0","doc":"","ref":"Kuddle.Config.Provider.html#t:options/0"},{"type":"type","title":"Kuddle.Config.Provider.path_option/0","doc":"The path to the KDL config file that should be loaded.","ref":"Kuddle.Config.Provider.html#t:path_option/0"},{"type":"module","title":"Kuddle.Config.Types","doc":"Annotation cast types.\n\nUser specific types can be registered by setting the kuddle_config types:","ref":"Kuddle.Config.Types.html"},{"type":"module","title":"Example - Kuddle.Config.Types","doc":"config :kuddle_config,\n      types: [\n        typename: {Module, cast_function_name},\n\n        geopoint: {MyGeoPoint, :cast},\n      ]\n\nThe cast function must return {:ok, any()} or :error if it cannot cast the given value.\n\nKuddle Config has some default types they can be overwritten by setting the default_types:\n\n    config :kuddle_config,\n      default_types: [\n        date: {Date, :from_iso8601},\n        utc_datetime: {Kuddle.Config.Types.DateTime, :cast},\n        naive_datetime: {NaiveDateTime, :from_iso8601},\n        time: {Time, :from_iso8601},\n        decimal: {Kuddle.Config.Types.Decimal, :cast},\n        atom: {Kuddle.Config.Types.Atom, :cast},\n        boolean: {Kuddle.Config.Types.Boolean, :cast},\n        tuple: {Kuddle.Config.Types.Tuple, :cast},\n        list: {Kuddle.Config.Types.List, :cast},\n      ]\n\nThe purpose of the default_types is to provide some sane default which doesn't require any\nadditional configuration from you, the user.\n\nHowever they can be disabled by setting the default_types config.","ref":"Kuddle.Config.Types.html#module-example"},{"type":"function","title":"Kuddle.Config.Types.cast/2","doc":"Cast given value to a different type, normally the input will a string.","ref":"Kuddle.Config.Types.html#cast/2"},{"type":"function","title":"Kuddle.Config.Types.internal_cast/2","doc":"","ref":"Kuddle.Config.Types.html#internal_cast/2"},{"type":"module","title":"Kuddle.Config.Types.Atom","doc":"","ref":"Kuddle.Config.Types.Atom.html"},{"type":"function","title":"Kuddle.Config.Types.Atom.cast/1","doc":"","ref":"Kuddle.Config.Types.Atom.html#cast/1"},{"type":"module","title":"Kuddle.Config.Types.Boolean","doc":"","ref":"Kuddle.Config.Types.Boolean.html"},{"type":"function","title":"Kuddle.Config.Types.Boolean.cast/1","doc":"","ref":"Kuddle.Config.Types.Boolean.html#cast/1"},{"type":"module","title":"Kuddle.Config.Types.DateTime","doc":"","ref":"Kuddle.Config.Types.DateTime.html"},{"type":"function","title":"Kuddle.Config.Types.DateTime.cast/1","doc":"","ref":"Kuddle.Config.Types.DateTime.html#cast/1"},{"type":"module","title":"Kuddle.Config.Types.Decimal","doc":"","ref":"Kuddle.Config.Types.Decimal.html"},{"type":"function","title":"Kuddle.Config.Types.Decimal.cast/1","doc":"","ref":"Kuddle.Config.Types.Decimal.html#cast/1"},{"type":"module","title":"Kuddle.Config.Types.List","doc":"","ref":"Kuddle.Config.Types.List.html"},{"type":"function","title":"Kuddle.Config.Types.List.cast/1","doc":"","ref":"Kuddle.Config.Types.List.html#cast/1"},{"type":"module","title":"Kuddle.Config.Types.Tuple","doc":"","ref":"Kuddle.Config.Types.Tuple.html"},{"type":"function","title":"Kuddle.Config.Types.Tuple.cast/1","doc":"","ref":"Kuddle.Config.Types.Tuple.html#cast/1"},{"type":"module","title":"Kuddle.Config.Utils","doc":"","ref":"Kuddle.Config.Utils.html"},{"type":"function","title":"Kuddle.Config.Utils.apply_configuration/1","doc":"","ref":"Kuddle.Config.Utils.html#apply_configuration/1"},{"type":"function","title":"Kuddle.Config.Utils.deep_merge/2","doc":"","ref":"Kuddle.Config.Utils.html#deep_merge/2"},{"type":"function","title":"Kuddle.Config.Utils.deep_merge/3","doc":"","ref":"Kuddle.Config.Utils.html#deep_merge/3"},{"type":"function","title":"Kuddle.Config.Utils.mod_to_atom/1","doc":"","ref":"Kuddle.Config.Utils.html#mod_to_atom/1"},{"type":"function","title":"Kuddle.Config.Utils.mod_to_existing_atom/1","doc":"","ref":"Kuddle.Config.Utils.html#mod_to_existing_atom/1"},{"type":"function","title":"Kuddle.Config.Utils.resolve_root_path!/1","doc":"","ref":"Kuddle.Config.Utils.html#resolve_root_path!/1"},{"type":"exception","title":"Kuddle.ConfigError","doc":"","ref":"Kuddle.ConfigError.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}